import { _ as _objectWithoutPropertiesLoose } from './index.esm2.js';
import React__default from 'react';
import PropTypes from 'prop-types';
import RichTextEditor from 'react-rte';
import { jsxs, jsx } from 'react/jsx-runtime';
import '@qubejs/core';
import '@mui/material/Button';
import '@mui/material/IconButton';
import '@mui/material/Typography';
import '@mui/material/Dialog';
import '@mui/material/DialogTitle';
import '@mui/material/DialogActions';
import '@mui/material/DialogContent';
import '@mui/material/Slide';
import '@mui/material/LinearProgress';
import '@mui/material/CircularProgress';
import '@mui/icons-material/SelectAll';
import '@mui/lab/Alert';
import '@mui/lab/AlertTitle';
import '@mui/material/Autocomplete';
import '@mui/material/Chip';
import '@mui/material/Box';
import '@mui/material';
import '@mui/material/TextField';
import '@mui/material/BottomNavigation';
import '@mui/material/BottomNavigationAction';
import '@mui/material/Breadcrumbs';
import '@mui/icons-material/NavigateNext';
import '@mui/material/ButtonGroup';
import '@mui/material/Tooltip';
import '@mui/material/FormLabel';
import '@mui/material/FormControl';
import '@mui/material/FormControlLabel';
import '@mui/material/Checkbox';
import '@mui/material/FormGroup';
import '@mui/material/FormHelperText';
import '@mui/material/Menu';
import '@mui/material/MenuItem';
import '@mui/material/ListItemIcon';
import '@mui/material/Divider';
import '@mui/material/List';
import '@mui/material/ListItem';
import '@mui/material/ListItemButton';
import '@mui/material/ListItemText';
import '@mui/material/Collapse';
import '@mui/material/Avatar';
import '@mui/material/Select';
import '@mui/material/OutlinedInput';
import '@mui/material/Input';
import '@mui/material/InputLabel';
import '@mui/material/Pagination';
import '@mui/material/Radio';
import '@mui/material/RadioGroup';
import 'react-google-recaptcha';
import '@mui/material/Skeleton';
import '@mui/material/Snackbar';
import '@mui/icons-material/Close';
import '@mui/material/Switch';
import '@mui/material/Tabs';
import '@mui/material/Tab';
import 'react-dom';
import 'react-router-dom';
import '@mui/lab/TreeView';
import '@mui/icons-material/ExpandMore';
import '@mui/icons-material/ChevronRight';
import '@mui/lab/TreeItem';

const _excluded = ["label", "className", "formatter", "value", "error", "errorMessage"];
function getText(html) {
  var divContainer = document.createElement('div');
  divContainer.innerHTML = html;
  return divContainer.textContent || divContainer.innerText || '';
}
class BasicRTE extends React__default.Component {
  constructor() {
    super();
    this.state = {
      value: RichTextEditor.createEmptyValue(),
      focused: false,
      hasChanged: false
    };
    this.handleFocus = this.handleFocus.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.handleOnChange = this.handleOnChange.bind(this);
  }
  handleOnChange(value) {
    const html = value.toString('html');
    const hasText = getText(html);
    this.setState({
      value: value,
      hasChanged: true
    });
    const {
      onChange
    } = this.props;
    onChange && onChange({
      value: hasText && html
    });
  }
  componentDidMount() {
    if (this.props.value) {
      this.setState({
        value: RichTextEditor.createValueFromString(this.props.value, 'html')
      });
    }
  }
  componentDidUpdate(prevProps) {
    if (!this.state.focused && prevProps.value !== this.props.value) {
      this.setState({
        value: RichTextEditor.createValueFromString(this.props.value, 'html')
      });
    }
  }
  handleFocus() {
    this.setState({
      focused: true
    });
  }
  handleBlur() {
    this.props;
    this.setState({
      focused: false
    });
  }
  render() {
    const {
      focused
    } = this.state;
    const _this$props = this.props,
      {
        label,
        className = '',
        error,
        errorMessage
      } = _this$props;
      _objectWithoutPropertiesLoose(_this$props, _excluded);
    return /*#__PURE__*/jsxs("div", {
      className: `sq-basic-rte${focused ? ' sq-basic-rte--focused' : ''} ${className}`,
      children: [label && /*#__PURE__*/jsx("label", {
        htmlFor: "",
        children: label
      }), /*#__PURE__*/jsx(RichTextEditor, {
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onChange: this.handleOnChange,
        className: `sq-basic-rte__editor`,
        defaultValue: this.props.value,
        value: this.state.value
      }), !focused && error && /*#__PURE__*/jsx("div", {
        className: "sq-textarea-field--error",
        children: errorMessage
      })]
    });
  }
}
BasicRTE.propTypes = {
  errorMessage: PropTypes.string,
  className: PropTypes.string,
  value: PropTypes.any,
  formatter: PropTypes.object,
  onChange: PropTypes.func,
  onKeyPress: PropTypes.func,
  onBlur: PropTypes.func
};

export { BasicRTE as default };
